;***********   183031 *************
$MOD51
;  
FLAGS   EQU    02FH  ; :
FL7     EQU    07    ; =0 -   +
                     ; =1 -   -
FL6     EQU    06    ; =0 -  "F"
                     ; =1 -  "dF"
FL5     EQU    05    ; =0 -   .  
                     ; =1 -  (1-  .    "dF")
TMP1    EQU    30H   ; 
FRQ2I   EQU    31H   ; . . .  31H(.)-34H(.)
TMP2    EQU    35H   ; 
FRQ2E   EQU    36H   ; . . .  36H-39H
FRQ10   EQU    3AH   ; .-.    3AH-41H
OUTIN   EQU    42H   ; ,   . 42H-49H
LOWZAD  EQU    4AH   ; .  2
HIGHZAD EQU    4BH   ; .  2
CONZ    EQU    4CH   ; 1

; K2= 7+65536*K1-F/12  F-   , 
;  F=6144600 K1=8, K2=12245=2FD5H
; K2     

; 7-  :
;  H     B     . 
; ------------------------------
; 04  00000100  00       0
; 9E  10011110  01       1
; 22  00100010  02       2
; 0A  00001010  03       3
; 98  10011000  04       4
; 48  01001000  05       5
; 40  01000000  06       6
; 1E  00011110  07       7
; 00  00000000  08       8
; 08  00001000  09       9
; F0  11110000  0A       +
; FA  11111010  0B       -
; 3C  00111100  0C       
; FE  11111110  0D     
; FE  11111110  0E     
; FE  11111110  0F     

        ORG    0000H
        AJMP   NEWYEAR      ;  " "
        DB     0FFH,0FFH,0FFH,0FFH,0FFH
        DB     0FFH,0FFH,0FFH,0FFH

; / . .   TMR0
        ORG    000BH
        DJNZ   R7,ENDTMR    ;  
        CLR    P3.0         ;  .  ..
        CLR    TCON.4       ;  TMR0
ENDTMR: RETI

        DB     0FFH,0FFH,0FFH,0FFH,0FFH
        DB     0FFH,0FFH,0FFH,0FFH
; / . .   TMR1
        ORG    001BH
        INC    R6           ;  
        NOP
        RETI

        DB     0FFH,0FFH
;   
        ORG    0020H
INIT1:  MOV    IP,#002H     ;  . TMR0
;----------------------------------------------------
;  AT89C51 
;        MOV    P3,#0BEH     ;  .  ..
;  5735
        MOV    P3,#0FEH     ;  .  ..
;----------------------------------------------------
        MOV    TMOD,#051H   ; TMR1-, TMR0-, 16, GATE=0
        MOV    IE,#08AH     ; . . TMR1, TMR0
        MOV    TCON,#040H   ; . TMR1
        MOV    FLAGS,#000H  ;  F
        MOV    R0,#OUTIN+7  ;  .   .  .
        MOV    R2,#008H     ; - 
INIT3:  MOV    A,R2
        ACALL  PKD1         ; /  HELLO
        MOV    @R0,A        ;  HELLO
        DEC    R0           ; /
        DJNZ   R2,INIT3     ; /
        MOV    R6,#0FFH
        MOV    TH1,R6       ; -  "0"  
        MOV    TL1,R6       ; /
INIT2:  CLR    P3.1         ; /
        SETB   P3.1         ; /
        NOP                 ; /
        CJNE   R6,#00,INIT2 ; /
;   
        MOV    DPTR,#TABCON ;   
        CLR    A
Z1:     MOVC   A,@A+DPTR    ; K1
        INC    DPTR
        JZ     Z1           ; =0,  . 
        MOV    CONZ,A       ;  K1
        CLR    A
        MOVC   A,@A+DPTR
        MOV    HIGHZAD,A    ;  .  K2
        MOV    A,#01
        MOVC   A,@A+DPTR
        MOV    LOWZAD,A     ;  .  K2
;  
IZM:    MOV    TL0,LOWZAD
        MOV    TH0,HIGHZAD
        MOV    R7,CONZ      ; -  TMR0
        SETB   P3.0         ; . .   
        SETB   TCON.4       ;  TMR0
N3:     ACALL  SCN1         ;  
        JB     P3.2,N2      ; dF  
        SETB   FLAGS.FL6    ;  dF
        SETB   FLAGS.FL5    ; 1-   dF
N2:     JB     P3.3,N5      ; F  
        CLR    FLAGS.FL6    ;  F
        NOP                 ;    - 
N5:     MOV    R5,#0FFH
        NOP                 ;    - 
N6:     DJNZ   R5,N6        ; 
        JB     TCON.4,N3    ;   
;       FRQ2I+3...FRQ2I
;                                                   ..    ..
        MOV    FRQ2I+3,R6   ; .  (- . TMR1)
        MOV    FRQ2I+2,TH1  ;  TMR1
        MOV    FRQ2I+1,TL1  ; /
        MOV    FRQ2I,#004H  ; .   . 
        MOV    TMP1,#001H   ; .   . 
        MOV    R6,#0FFH
        NOP                 ;    - 
        MOV    TH1,R6
        MOV    TL1,R6
PER2:   CLR    P3.1         ;    . 
        SETB   P3.1         ; /
        DJNZ   TMP1,PER1
        DEC    FRQ2I        ; .  . 
        NOP                 ;    - 
        ACALL  SCN1
PER1:   CJNE   R6,#00,PER2  ;    TMR1
        DEC    TMP1         ; .  . 
        MOV    R2,#02       ; - .  3- .  
PER3:   CLR    C
        NOP                 ;    - 
        MOV    R0,#FRQ2I    ;  . -1
        MOV    R3,#03       ; - 
        ACALL  SDV1         ;     
        DJNZ   R2,PER3
        MOV    A,FRQ2I      ; .. . 
        ORL    FRQ2I+1,A
        MOV    FRQ2I,TMP1
        ACALL  SCN1
        JNB    FLAGS.FL5,N8 ;   .  
        CLR    FLAGS.FL5
;  .  34H...31H  39H...36H -   dF
        MOV    R2,#004H     ; - 
        MOV    R0,#FRQ2I    ; 
        MOV    R1,#FRQ2E    ; 
PRM2:   MOV    A,@R0
        MOV    @R1,A
        INC    R0
        INC    R1
        DJNZ   R2,PRM2
N8:     JNB    FLAGS.FL6,N4 ;  F
;     (34H...31H)  (39H...36H)
;      , -  
        CLR    C
        MOV    R2,#04
        MOV    R0,#FRQ2I    ;  . 
        MOV    R1,#FRQ2E    ;   
SUB2:   MOV    A,@R0        ; 
        SUBB   A,@R1        ; /
        INC    R0           ; /
        INC    R1           ; /
        DJNZ   R2,SUB2      ; /
        MOV    FLAGS.FL7,C
        MOV    R2,#04
        MOV    R0,#FRQ2I
        MOV    R1,#FRQ2E
        JC     SUB3         ;   > 
        NOP                 ;    - 
;    
SUB4:   MOV    A,@R0
        SUBB   A,@R1 
        MOV    @R0,A
        INC    R0
        INC    R1
        DJNZ   R2,SUB4
        SJMP   N4
;    
SUB3:   CLR    C
SUB6:   MOV    A,@R1
        SUBB   A,@R0
        MOV    @R0,A
        INC    R0
        INC    R1
        DJNZ   R2,SUB6
N4:     ACALL  SCN1
;  4-    .  (FRQ2I+3...FRQ2I)
;  2-10 (FRQ10+7...FRQ10),    . 8- , FRQ2I=0
        MOV    R4,#08       ; -  
        MOV    R1,#FRQ10    ;  .. .
TRN2:   ACALL  DEL1         ; /10
        MOV    @R1,TMP2     ; 
        INC    R1
        ACALL  SCN1
        DJNZ   R4,TRN2
;   8-     
        MOV    R1,#FRQ10+7  ;  . 
        MOV    A,FRQ2I
        JNZ    ANA2         ; 
        JNB    FLAGS.FL6,GN1 ;  F
        MOV    A,@R1        ; A - . 
        NOP
        JZ     ANA5         ; .  =0
        ACALL  PRP1         ;  0CH ()
ANA5:   MOV    FRQ10+7,#0AH ; +
        JNB    FLAGS.FL7,GN1 ;   +
        MOV    FRQ10+7,#0BH ; -
        SJMP   GN1

ANA2:   ACALL  PRP1         ;  0CH ()
;     
GN1:    MOV    R2,#08       ; - 
        MOV    R1,#FRQ10+7  ; . 
        JB     FLAGS.FL6,GN4 ; .  - 
GN3:    CJNE   @R1,#00,GN5  ;  0
        MOV    @R1,#0FH     ;  
GN4:    DEC    R1
        DJNZ   R2,GN3
GN5:    ACALL  SCN1
;     
        MOV    R2,#08       ; - 
        MOV    R1,#FRQ10    ;  . 
        MOV    R0,#OUTIN    ;  .   
        MOV    R4,#0B7H     ;   
        JB     P3.4,DS1     ;  
        MOV    R4,#0DBH     ;   
        NOP
DS1:    MOV    A,R4
        RRC    A            ;  -->C
        MOV    R4,A         ;   . 
        MOV    A,@R1        ; A -  
        ACALL  PKD          ;   7- . 
        RRC    A            ;    . 
        MOV    @R0,A
        INC    R1
        INC    R0
        DJNZ   R2,DS1
        AJMP   IZM          ;  

; /   8   0CH ()
; : R1 -  . 
PRP1:   MOV    R2,#08H
        NOP
PRP2:   MOV    @R1,#0CH
        DEC    R1
        DJNZ   R2,PRP2
        RET

; /    7-  
PKD:    INC    A
        MOVC   A,@A+PC
        RET
TAB:    DB     04H,9EH,22H,0AH,98H,48H,40H,1EH,00H,08H ;0-9
        DB     0F0H,0FAH,3CH  ; +,-,
        DB     0FEH,0FEH,0FEH ; 
 
; /  4-    10
; :  FRQ2I(.)...FRQ2I+3(.) - 
; : FRQ2I(.)...FRQ2I+3(.) - , TMP2 - 
DEL1:   MOV    TMP2,#00     ;  .
        MOV    R2,#020H     ; -  
DEL3:   MOV    R3,#05H      ; -  
        ACALL  SDV2         ;  5    
        CLR    C
        SUBB   A,#0AH       ;  
        CPL    C
        JNC    DEL2
        MOV    @R0,A        ;  
        NOP
DEL2:   DJNZ   R2,DEL3
        MOV    R3,#04H
        ACALL  SDV2         ; .  .  . 
        RET

; /    1  
SDV2:   MOV    R0,#TMP1     ;  . . -1
SDV1:   INC    R0
        MOV    A,@R0
        RLC    A
        MOV    @R0,A
        DJNZ   R3,SDV1
        RET

; /  "HELLO"
PKD1:   MOVC   A,@A+PC
        RET
TAB1:   DB     0FFH,0FFH,0FFH          ; 
        DB     82H,0F2H,0F2H,0B0H,0C8H ; HELLO

; /  
; : OUTIN+7...OUTIN -  
SCN1:   MOV    R2,#08       ; - 
        MOV    R0,#OUTIN    ;  . 
        MOV    A,#0FEH
        NOP
;--------------------------------------------
;  AT89C51 
;SCN3:   MOV    P0,A         ;   
;        RL     A            ;  
;        MOV    P1,@R0       ;    
;  5735
SCN3:  MOVX   @R0,A        ;   
        MOV    P1,@R0       ;    
        NOP
        RL     A
;-------------------------------------------- 
        INC    R0
        MOV    R5,#080H     ; CONST   
SCN4:   NOP
        NOP
        DJNZ   R5,SCN4      ; 
        MOV    P1,#0FFH     ;  
        DJNZ   R2,SCN3
        RET

;    
TABCON: DB     08H         ; K1
        DB     2FH         ; .. K2
        DB     0D5H        ; .. K2

;     FF

   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH       ; 01BF
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH

;*************   ****************

;  
INDYR   EQU    30H   ; 30H-37H   
                     ; 38H-3FH     
COUNT   EQU    40H   ;   .
TMPIN   EQU    41H   ; /
TMPIND  EQU    42H   ; /
CONV    EQU    43H   ;   
LOWY    EQU    44H   ; 2 .  
HIGHY   EQU    45H   ; 2 .    .
SAVEYR  EQU    4CH   ; 4CH-4FH -   
BRIGHT  EQU    50H   ; 50H-57H - . .  

;-------------------------------------------------
;  AT89C51
;        ORG    0200H
;NEWYEAR: JNB    P3.2,YEAR1  ;  dF
;        JB     P3.3,YEAR2   ;   F
;        DB     0FFH,0FFH
;YEAR2:  AJMP   INIT1        ;  . 
;YEAR1:  CLR    P3.6         ;  DD3

;  5735
;     FF

  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
  DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH

        ORG    0500H
NEWYEAR: JNB    P3.2,YEAR3  ;  dF
        JB     P3.3,YEAR2   ;   F
        DB     0FFH,0FFH,0FFH
YEAR2:  LJMP   INIT1        ;  . 
;-------------------------------------------------

YEAR3:  MOV    DPTR,#TABCONY  ;   
        CLR    A
YEAR4:  MOVC   A,@A+DPTR     ;  
        INC    DPTR
        JZ     YEAR4         ; =0,  
        MOV    CONV,A
        CLR    A
YEAR5:  MOVC   A,@A+DPTR     ; 2 .  
        INC    DPTR
        JZ     YEAR5
        MOV    HIGHY,A
        CLR    A
        MOVC   A,@A+DPTR     ; 2 .  
        MOV    LOWY,A
        MOV    R3,#01
        ACALL  GAI1           ;  
        MOV    R3,#0D0H      ; 
;     
PKDYR:  MOV    R2,#02        ; - 
        MOV    R1,#LOWY      ;  2- .  
        MOV    R0,#INDYR+2   ;   .   
PKDY1:  MOV    A,#00FH
        ANL    A,@R1         ;  . 
        ACALL  PKDSIM        ; 
        MOV    @R0,A         ; .  
        INC    R0            ;  . 
        MOV    A,#0F0H
        ANL    A,@R1         ;  . 
        SWAP   A             ; . .   .
        ACALL  PKDSIM
        MOV    @R0,A
        INC    R0
        INC    R1
        DJNZ   R2,PKDY1
PKDY2:  ACALL  INDIC         ;    
        ACALL  INDIC
        DJNZ   R3,PKDY2
        JB     P3.2,PKDY3    ; dF  ,  
        MOV    R1,#LOWY      ;  2- .  
;  
        MOV    A,@R1
        ADD    A,#001H
        DA     A
        MOV    @R1,A
        INC    R1
        MOV    A,@R1
        ADDC   A,#000H
        DA     A
        MOV    @R1,A         ;  +1
        MOV    R3,#060H      ;   
        SJMP   PKDYR
;   
PKDY3:  MOV    R2,#04        ; - 
        MOV    R0,#INDYR+2   ; 
        MOV    R1,#SAVEYR    ; 
        ACALL  MOVYR         ;    SAVEYR...SAVEYR+3
;  
CIKL:   ACALL  GAI           ;  
;  1
        MOV    R3,#10H       ; -  
SHOW1:  MOV    R4,#05H       ; - 
        MOV    DPTR,#PIC1    ;   
SHW11:  ACALL  MOVOUT        ;     .
        DJNZ   R4,SHW11      ;  
        DJNZ   R3,SHOW1      ; 
        MOV    R3,#01
        ACALL  GAI1          ;  
;  2
        MOV    A,#0FDH       ; "-"
        MOV    INDYR,A       ;  --xxxx--
        MOV    INDYR+1,A     ; /
        MOV    INDYR+6,A     ; /
        MOV    INDYR+7,A     ; /
        MOV    R1,#INDYR+2
        MOV    R0,#SAVEYR    ;  
        MOV    R2,#04        ; - 
        ACALL  MOVYR         ;      .
        MOV    A,CONV        ;  
        MOV    B,#03
        DIV    AB
        MOV    R3,A          ; /3
        CLR    C
        MOV    A,CONV
        SUBB   A,R3
        MOV    LOWY,A        ; . 
        MOV    R3,#00FH      ; - 
;  
SHOW2:  MOV    R2,LOWY
SHOW21: MOV    R1,#BRIGHT+2  ;   .   
        MOV    A,@R1
        CJNE   A,CONV,SHOW22 ;   max 
        INC    R1            ; . 
        SJMP   SHOW23
SHOW22: INC    @R1           ;   2- 
        INC    R1
        INC    @R1
SHOW23: INC    R1            ;   2- 
        DEC    @R1
        INC    R1
        DEC    @R1
        ACALL  INDIC         ;   .
        DJNZ   R2,SHOW21     ;  - 
        MOV    R2,LOWY
SHOW24: MOV    R1,#BRIGHT+5  ;  . .  
        INC    @R1
        DEC    R1
        INC    @R1
        DEC    R1
        DEC    @R1
        DEC    R1
        DEC    @R1
        ACALL  INDIC
        DJNZ   R2,SHOW24     ;  - 
        DJNZ   R3,SHOW2      ; 
        ACALL  GAI
;  3
        ACALL  MRIGHT        ;  
        ACALL  GAI
        ACALL  MLEFT         ;  
;  4 ()
        MOV    DPTR,#PIC3    ;  
        ACALL  MOV8IN        ;   .  .
        MOV    R4,#07        ; - 
SHOW4:  ACALL  BRON          ;  
        MOV    R3,#0E0H      ;  
SHOW41: ACALL  INDIC
        DJNZ   R3,SHOW41
        ACALL  BROFF         ;  
        DJNZ   R4,SHOW4      ; 
        ACALL  GAI
;  5
        MOV    R3,#010H      ; - 
SHOW5:  MOV    R4,#04        ; - 
        MOV    DPTR,#PIC5    ;  1- 
SHOW51: ACALL  MOVOUT        ;    
        DJNZ   R4,SHOW51
        DJNZ   R3,SHOW5
        ACALL  GAI
;  6
        MOV    R3,#00DH
SHOW6:  MOV    R4,#06
        MOV    DPTR,#PIC6
SHOW61: ACALL  MOVOUT
        DJNZ   R4,SHOW61
        DJNZ   R3,SHOW6
        AJMP   CIKL           ;   

; /  
BROFF:  MOV    COUNT,CONV      ; max 
BROF1:  ACALL  CONBR           ; -   
        ACALL  INDIC
        DJNZ   COUNT,BROF1
        RET
; /  
BRON:   MOV    R3,CONV         ; max 
        MOV    COUNT,#01
BRON1:  ACALL  CONBR
        ACALL  INDIC
        INC    COUNT
        DJNZ   R3,BRON1
        RET

; /  8-   --> 
; : DPTR - .  
MOV8IN: MOV    R0,#INDYR       ;   
MOV8N:  MOV    R2,#08          ; - 
MOV8N1: CLR    A
        MOVC   A,@A+DPTR
        MOV    @R0,A
        INC    R0
        INC    DPTR
        DJNZ   R2,MOV8N1
        RET

; / -    
; : COUNT -  
CONBR:  MOV    R1,#BRIGHT      ; . 
        MOV    R2,#08          ; -
CNBR1:  MOV    @R1,COUNT       ; 
        INC    R1
        DJNZ   R2,CNBR1
        RET

; /   
; : INDYR...INDIR+7 - , BRIGHT...BRIGHT+7 - 
INDIC:  MOV    TMPIN,#08        ; - 
        MOV    R0,#INDYR       ;  . 
        MOV    R1,#BRIGHT      ;  . .
        MOV    A,#0FEH         ; .  .
;--------------------------------------------------
;  AT89C51
;INDIC1: MOV    P0,A            ;  
;        MOV    P1,@R0          ;  
;  5735
INDIC1: MOVX   @DPTR,A        ;  
        MOV    P1,@R0         ;  
        NOP
;--------------------------------------------------
        RL     A
        INC    R0              ;  . .
        PUSH   ACC
        CLR    C
        MOV    A,CONV          ;  
        SUBB   A,@R1           ;   
        INC    A
        MOV    TMPIND,@R1      ;   
INDIC2: NOP
        NOP
        DJNZ   TMPIND,INDIC2   ;    
        MOV    P1,#0FFH        ;  .
        MOV    TMPIND,A
        POP    ACC
        INC    R1              ;   . 
INDIC3: NOP
        NOP
        DJNZ   TMPIND,INDIC3   ;    
        DJNZ   TMPIN,INDIC1    ; . 
        RET

; /  
GAI:    MOV    R3,#COUNT       ; 
GAI1:   MOV    DPTR,#DARC      ; 8  0FFH
        ACALL  MOV8IN          ; 
        MOV    COUNT,CONV      ; . .
        ACALL  CONBR           ; . 
GAI2:   ACALL  INDIC
        DJNZ   R3,GAI2
        RET

; /   
RIGHT:  MOV    R4,#08          ; - 
RYGHT1: MOV    R3,#015H        ; 
        MOV    R2,#010H        ; - 
        MOV    R0,#INDYR       ;   
        MOV    A,INDYR+0FH     ;   
RYGHT2: XCH    A,@R0           ; INDIR --> INDIR+1 -->...INDIR+0FH
        INC    R0              
        DJNZ   R2,RYGHT2
RYGHT3: ACALL  INDIC
        DJNZ   R3,RYGHT3
        DJNZ   R4,RYGHT1
        RET

; /   
LEFT:   MOV    R4,#08          ; -  
LEFT1:  MOV    R3,#015H        ;  
        MOV    R2,#010H        ; -  
        MOV    R0,#INDYR+0FH   ;    
        MOV    A,INDYR         ;    
LEFT2:  XCH    A,@R0           ; INDIR <-- INDIR+1 <--...INDIR+0FH 
        DEC    R0              ;   \----------- > -----------/
        DJNZ   R2,LEFT2
LEFT3:  ACALL  INDIC
        DJNZ   R3,LEFT3
        DJNZ   R4,LEFT1
        RET

; /   
MRIGHT: MOV    DPTR,#PIC2
        MOV    R0,#INDYR+8     ;  
        ACALL  MOV8N           ;   
        ACALL  RIGHT           ;  
        MOV    DPTR,#DARC      ; 
        MOV    R0,#INDYR+8
        ACALL  MOV8N
        ACALL  RIGHT
        RET

; /   
MLEFT:  MOV    DPTR,#PIC2
        MOV    R0,#INDYR+8      ;  
        ACALL  MOV8N            ;    
        ACALL  LEFT             ;  
        MOV    DPTR,#DARC       ; 
        MOV    R0,#INDYR+8
L03B0:  ACALL  MOV8N
        ACALL  LEFT
        RET

; /  .    
MOVOUT: ACALL  MOV8IN           ; 
        MOV    R2,#020H         ;  
MOVOT1: ACALL  INDIC            ; 
        DJNZ   R2,MOVOT1
        RET

; /   
; : R2 - - 
MOVYR:  MOV    A,@R0            ; 
        MOV    @R1,A            ; 
        INC    R0
        INC    R1
        DJNZ   R2,MOVYR
        RET

; /  7-  
PKDSIM: INC    A
        MOVC   A,@A+PC
        RET
        DB     082H,0CFH,091H,085H,0CCH,    ; 0,1,2,3,4
        DB     0A4H,0A0H,08FH,080H,084H     ; 5,6,7,8,9

; ****************  ************************
; 
PIC3:   DB     082H,0C8H,0C2H,080H,0FFH,0C2H,0B0H,08AH
; 
PIC2:   DB     0FDH,0B5H,0B5H,0B5H,0B5H,0B5H,0FDH,0FFH
; .  4 
PIC1:   DB     0FFH,0FFH,0FFH,0B5H,0B5H,0FFH,0FFH,0FFH
        DB     0FFH,0FFH,0B5H,0FFH,0FFH,0B5H,0FFH,0FFH
        DB     0FFH,0B5H,0FFH,0FFH,0FFH,0FFH,0B5H,0FFH
        DB     0B5H,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0B5H
; 
DARC:   DB     0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
;  5
PIC5:   DB     0BFH,0FDH,0FDH,0F7H,0F7H,0FDH,0FDH,0BFH
        DB     0FDH,0F7H,0F7H,0FFH,0FFH,0F7H,0F7H,0FDH
        DB     0F7H,0FFH,0FFH,0BFH,0BFH,0FFH,0FFH,0F7H
        DB     0FFH,0BFH,0BFH,0FDH,0FDH,0BFH,0BFH,0FFH
;  6
PIC6:   DB     0BFH,0BFH,0FEH,0FBH,0F7H,0EFH,0DFH,0DFH
        DB     0FEH,0FEH,0FBH,0F7H,0EFH,0DFH,0BFH,0BFH
        DB     0FBH,0FBH,0F7H,0EFH,0DFH,0BFH,0FEH,0FEH
        DB     0F7H,0F7H,0EFH,0DFH,0BFH,0FEH,0FBH,0FBH
        DB     0EFH,0EFH,0DFH,0BFH,0FEH,0FBH,0F7H,0F7H
        DB     0DFH,0DFH,0BFH,0FEH,0FBH,0F7H,0EFH,0EFH
;    
TABCONY: DB     052H,019H,096H

;     07FFH  0FFH

   DB 0FFH,0FFH,0FFH   ; 045F  AT8951, 075F  5735
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;------------------------------------------------------------
;  AT89C51   07FFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH
;   DW 0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH

        END

